"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from ascend_sdk.types import BaseModel
from enum import Enum
from typing import TypedDict


class DocumentType(str, Enum):
    r"""Describes the contents of a document and how it is used; Required for all account documents"""
    ACCOUNT_DOCUMENT_TYPE_UNSPECIFIED = "ACCOUNT_DOCUMENT_TYPE_UNSPECIFIED"
    CERTIFICATE_OF_APPOINTMENT = "CERTIFICATE_OF_APPOINTMENT"
    FDIC_SWEEP_PROGRAM_AGREEMENT = "FDIC_SWEEP_PROGRAM_AGREEMENT"
    FPSL_MASTER_SERVICES_LOAN_AGREEMENT = "FPSL_MASTER_SERVICES_LOAN_AGREEMENT"
    TRANSFER_ON_DEATH_BENEFICIARY_DESIGNATION = (
        "TRANSFER_ON_DEATH_BENEFICIARY_DESIGNATION"
    )
    CHANGE_OF_ADDRESS = "CHANGE_OF_ADDRESS"
    NEW_ACCOUNT_FORM = "NEW_ACCOUNT_FORM"
    LETTER_3210 = "LETTER_3210"
    IRA_APPL_FORM = "IRA_APPL_FORM"
    RIA_IRA_APPL_FORM = "RIA_IRA_APPL_FORM"
    IRA_DEPOSIT_FORM = "IRA_DEPOSIT_FORM"
    RIA_IRA_DEPOSIT_FORM = "RIA_IRA_DEPOSIT_FORM"
    IRA_DIST_FORM = "IRA_DIST_FORM"
    RIA_IRA_DIST_FORM = "RIA_IRA_DIST_FORM"
    ROTH_APPL_FORM = "ROTH_APPL_FORM"
    RIA_ROTH_APPL_FORM = "RIA_ROTH_APPL_FORM"
    ROTH_DIST_FORM = "ROTH_DIST_FORM"
    RIA_ROTH_DIST_FORM = "RIA_ROTH_DIST_FORM"
    SIMPLE_CONT_TRANSM = "SIMPLE_CONT_TRANSM"
    ESA_APPL_FORM = "ESA_APPL_FORM"
    ESA_WTHDR_STATEMENT = "ESA_WTHDR_STATEMENT"
    DIR_CONV_FORM = "DIR_CONV_FORM"
    MRGN_OPTA_AGREEMENT = "MRGN_OPTA_AGREEMENT"
    IRA_BENE_FORM = "IRA_BENE_FORM"
    IRA_JRNL_FORM = "IRA_JRNL_FORM"
    SEP_EMPL_PLAN_DOC = "SEP_EMPL_PLAN_DOC"
    SIMPLE_ADOPT_AGREEMENT = "SIMPLE_ADOPT_AGREEMENT"
    SIMPLE_APPL_FORM = "SIMPLE_APPL_FORM"
    DEATH_CERTIFICATION = "DEATH_CERTIFICATION"


class AccountDocumentUploadRequestCreateTypedDict(TypedDict):
    r"""Account document to be uploaded;"""

    account_id: str
    r"""Identifies the account relevant to the document; Required for all account documents"""
    correspondent_id: str
    r"""Identifies the correspondent relevant to the document; Required for all account documents"""
    document_type: DocumentType
    r"""Describes the contents of a document and how it is used; Required for all account documents"""


class AccountDocumentUploadRequestCreate(BaseModel):
    r"""Account document to be uploaded;"""

    account_id: str
    r"""Identifies the account relevant to the document; Required for all account documents"""
    correspondent_id: str
    r"""Identifies the correspondent relevant to the document; Required for all account documents"""
    document_type: DocumentType
    r"""Describes the contents of a document and how it is used; Required for all account documents"""
