"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .datecreate import DateCreate, DateCreateTypedDict
from ascend_sdk.types import BaseModel
from typing import Optional, TypedDict
from typing_extensions import NotRequired


class BrokerAmlPolicyInternalReviewCreateTypedDict(TypedDict):
    r"""Broker's anti-money laundering policy internal review detail."""

    internal_aml_policy_principal_review_date: NotRequired[DateCreateTypedDict]
    r"""Represents a whole or partial calendar date, such as a birthday. The time of day and time zone are either specified elsewhere or are insignificant. The date is relative to the Gregorian Calendar. This can represent one of the following:

    * A full date, with non-zero year, month, and day values * A month and day value, with a zero year, such as an anniversary * A year on its own, with zero month and day values * A year and month value, with a zero day, such as a credit card expiration date

    Related types are [google.type.TimeOfDay][google.type.TimeOfDay] and `google.protobuf.Timestamp`.
    """
    internal_aml_policy_principal_reviewer_name: NotRequired[str]
    r"""The name of the principal who reviewed the internal anti-money laundering policy"""
    internal_aml_policy_principal_reviewer_title: NotRequired[str]
    r"""The title of the principal who reviewed the internal anti-money laundering policy"""
    internally_reviewed_by_appropriate_principal: NotRequired[bool]
    r"""Indicates whether the anti-money laundering policy has been reviewed internally by an appropriate principal"""


class BrokerAmlPolicyInternalReviewCreate(BaseModel):
    r"""Broker's anti-money laundering policy internal review detail."""

    internal_aml_policy_principal_review_date: Optional[DateCreate] = None
    r"""Represents a whole or partial calendar date, such as a birthday. The time of day and time zone are either specified elsewhere or are insignificant. The date is relative to the Gregorian Calendar. This can represent one of the following:

    * A full date, with non-zero year, month, and day values * A month and day value, with a zero year, such as an anniversary * A year on its own, with zero month and day values * A year and month value, with a zero day, such as a credit card expiration date

    Related types are [google.type.TimeOfDay][google.type.TimeOfDay] and `google.protobuf.Timestamp`.
    """
    internal_aml_policy_principal_reviewer_name: Optional[str] = None
    r"""The name of the principal who reviewed the internal anti-money laundering policy"""
    internal_aml_policy_principal_reviewer_title: Optional[str] = None
    r"""The title of the principal who reviewed the internal anti-money laundering policy"""
    internally_reviewed_by_appropriate_principal: Optional[bool] = None
    r"""Indicates whether the anti-money laundering policy has been reviewed internally by an appropriate principal"""
