"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .depositedfundscreate import DepositedFundsCreate, DepositedFundsCreateTypedDict
from .financialprofilecreate import (
    FinancialProfileCreate,
    FinancialProfileCreateTypedDict,
)
from .plannedactivitycreate import PlannedActivityCreate, PlannedActivityCreateTypedDict
from ascend_sdk.types import BaseModel
from enum import Enum
from typing import TypedDict


class BrokerDeterminedAccountRiskRating(str, Enum):
    r"""The broker-determined account risk rating of the entity customer"""
    BROKER_DETERMINED_ACCOUNT_RISK_RATING_UNSPECIFIED = (
        "BROKER_DETERMINED_ACCOUNT_RISK_RATING_UNSPECIFIED"
    )
    LOW = "LOW"
    MEDIUM = "MEDIUM"
    HIGH = "HIGH"


class EntityAccountEnrollmentMetadataCreateTypedDict(TypedDict):
    r"""Enrollment metadata for Accounts that have a Legal Entity owner."""

    account_purpose: str
    r"""The purpose of the account"""
    anticipated_account_activity: str
    r"""The anticipated activity of the account. Include expected activity for money movements as well."""
    broker_determined_account_risk_rating: BrokerDeterminedAccountRiskRating
    r"""The broker-determined account risk rating of the entity customer"""
    deposited_funds: DepositedFundsCreateTypedDict
    r"""The initial amount of money placed into the account by the entity upon or after the account's establishment."""
    financial_profile: FinancialProfileCreateTypedDict
    r"""Disclosure of the entity account owner's financial relationships and source of brokerage funds; facilitates the creation of the overall customer risk profile"""
    planned_activity: PlannedActivityCreateTypedDict
    r"""Details the customer's intended trading and banking-related activities at the time of account application; informs risk checks and forms a baseline for anomalous activity detection"""


class EntityAccountEnrollmentMetadataCreate(BaseModel):
    r"""Enrollment metadata for Accounts that have a Legal Entity owner."""

    account_purpose: str
    r"""The purpose of the account"""
    anticipated_account_activity: str
    r"""The anticipated activity of the account. Include expected activity for money movements as well."""
    broker_determined_account_risk_rating: BrokerDeterminedAccountRiskRating
    r"""The broker-determined account risk rating of the entity customer"""
    deposited_funds: DepositedFundsCreate
    r"""The initial amount of money placed into the account by the entity upon or after the account's establishment."""
    financial_profile: FinancialProfileCreate
    r"""Disclosure of the entity account owner's financial relationships and source of brokerage funds; facilitates the creation of the overall customer risk profile"""
    planned_activity: PlannedActivityCreate
    r"""Details the customer's intended trading and banking-related activities at the time of account application; informs risk checks and forms a baseline for anomalous activity detection"""
