"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .ffieddupdate import FfiEddUpdate, FfiEddUpdateTypedDict
from .negativenewsupdate import NegativeNewsUpdate, NegativeNewsUpdateTypedDict
from .relatedpepupdate import RelatedPepUpdate, RelatedPepUpdateTypedDict
from ascend_sdk.types import BaseModel
from enum import Enum
from typing import List, Optional, TypedDict
from typing_extensions import NotRequired


class EntityEddUpdateBusinessIndustrialClassification(str, Enum):
    BUSINESS_INDUSTRIAL_CLASSIFICATION_UNSPECIFIED = (
        "BUSINESS_INDUSTRIAL_CLASSIFICATION_UNSPECIFIED"
    )
    AGRICULTURE_FORESTRY_AND_FISHING = "AGRICULTURE_FORESTRY_AND_FISHING"
    MINING = "MINING"
    CONSTRUCTION = "CONSTRUCTION"
    MANUFACTURING = "MANUFACTURING"
    TRANSPORTATION_COMMUNICATIONS_ELECTRIC_GAS_AND_SANITARY_SERVICES = (
        "TRANSPORTATION_COMMUNICATIONS_ELECTRIC_GAS_AND_SANITARY_SERVICES"
    )
    WHOLESALE_TRADE = "WHOLESALE_TRADE"
    RETAIL_TRADE = "RETAIL_TRADE"
    FINANCE_INSURANCE_AND_REAL_ESTATE = "FINANCE_INSURANCE_AND_REAL_ESTATE"
    SERVICES = "SERVICES"
    PUBLIC_ADMINISTRATION = "PUBLIC_ADMINISTRATION"


class EntityEddUpdateTypedDict(TypedDict):
    r"""Enhanced Due Diligence for Legal Entities required when a Legal Entity is the Primary Owner on an Account."""

    business_industrial_classification: NotRequired[
        EntityEddUpdateBusinessIndustrialClassification
    ]
    direct_or_indirect_related_politically_exposed_persons: NotRequired[bool]
    r"""Indicates whether the entity is directly or indirectly related to politically exposed persons"""
    entity_issues_bearer_shares: NotRequired[bool]
    r"""Indicates whether the entity issues bearer shares"""
    ffi_edd: NotRequired[FfiEddUpdateTypedDict]
    r"""Enhanced Due Diligence fields required for Foreign Financial Institutions."""
    foreign_bank: NotRequired[bool]
    r"""Indicates whether the entity is a foreign bank as defined by the Bank Secrecy Act via 31 CFR 103.176(c)"""
    foreign_bank_us_agent_for_process_of_service: NotRequired[str]
    r"""The name of the US agent for process of service if the entity is a foreign bank; receives legal documents on behalf of the foreign bank and enables the bank to be brought under U.S. jurisdiction in case of legal issues"""
    nature_of_business: NotRequired[str]
    r"""The nature of the business that the entity is involved in"""
    negative_news: NotRequired[NegativeNewsUpdateTypedDict]
    r"""Negative News detail."""
    parent_company_name: NotRequired[str]
    r"""The name of the parent company of the entity"""
    related_peps: NotRequired[List[RelatedPepUpdateTypedDict]]
    r"""Information about the related politically exposed persons"""


class EntityEddUpdate(BaseModel):
    r"""Enhanced Due Diligence for Legal Entities required when a Legal Entity is the Primary Owner on an Account."""

    business_industrial_classification: Optional[
        EntityEddUpdateBusinessIndustrialClassification
    ] = None
    direct_or_indirect_related_politically_exposed_persons: Optional[bool] = None
    r"""Indicates whether the entity is directly or indirectly related to politically exposed persons"""
    entity_issues_bearer_shares: Optional[bool] = None
    r"""Indicates whether the entity issues bearer shares"""
    ffi_edd: Optional[FfiEddUpdate] = None
    r"""Enhanced Due Diligence fields required for Foreign Financial Institutions."""
    foreign_bank: Optional[bool] = None
    r"""Indicates whether the entity is a foreign bank as defined by the Bank Secrecy Act via 31 CFR 103.176(c)"""
    foreign_bank_us_agent_for_process_of_service: Optional[str] = None
    r"""The name of the US agent for process of service if the entity is a foreign bank; receives legal documents on behalf of the foreign bank and enables the bank to be brought under U.S. jurisdiction in case of legal issues"""
    nature_of_business: Optional[str] = None
    r"""The nature of the business that the entity is involved in"""
    negative_news: Optional[NegativeNewsUpdate] = None
    r"""Negative News detail."""
    parent_company_name: Optional[str] = None
    r"""The name of the parent company of the entity"""
    related_peps: Optional[List[RelatedPepUpdate]] = None
    r"""Information about the related politically exposed persons"""
