"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .ffiamlcocontactinformationcreate import (
    FfiAmlcoContactInformationCreate,
    FfiAmlcoContactInformationCreateTypedDict,
)
from ascend_sdk.types import BaseModel
from typing import Optional, TypedDict
from typing_extensions import NotRequired


class FfiAmlProgramCreateTypedDict(TypedDict):
    r"""Foreign Financial Institution Anti-Money Laundering Program detail."""

    accepts_politically_exposed_persons_as_customers: NotRequired[bool]
    r"""Indicates whether the foreign financial institution accepts politically exposed persons as customers"""
    adhere_to_ofac_un_and_similar_database_restrictions: NotRequired[bool]
    r"""Indicates whether the foreign financial institution adheres to OFAC, UN, and similar database restrictions"""
    aml_program_description_in_lieu_of_related_questions: NotRequired[str]
    r"""A description of the FFI's anti-money laundering program in lieu of related questions"""
    ffi_amlco_contact_information: NotRequired[
        FfiAmlcoContactInformationCreateTypedDict
    ]
    r"""Foreign Financial Institution Anti-Money Laundering compliance contact information."""
    has_cip: NotRequired[bool]
    r"""Indicates whether the foreign financial institution has a Customer Identification Program (CIP)"""
    has_kyc: NotRequired[bool]
    r"""Indicates whether the foreign financial institution has a Know Your Customer (KYC) program"""
    pep_edd_procedure_description: NotRequired[str]
    r"""A description of the procedure for enhanced due diligence for politically exposed person customers of the FFI"""


class FfiAmlProgramCreate(BaseModel):
    r"""Foreign Financial Institution Anti-Money Laundering Program detail."""

    accepts_politically_exposed_persons_as_customers: Optional[bool] = None
    r"""Indicates whether the foreign financial institution accepts politically exposed persons as customers"""
    adhere_to_ofac_un_and_similar_database_restrictions: Optional[bool] = None
    r"""Indicates whether the foreign financial institution adheres to OFAC, UN, and similar database restrictions"""
    aml_program_description_in_lieu_of_related_questions: Optional[str] = None
    r"""A description of the FFI's anti-money laundering program in lieu of related questions"""
    ffi_amlco_contact_information: Optional[FfiAmlcoContactInformationCreate] = None
    r"""Foreign Financial Institution Anti-Money Laundering compliance contact information."""
    has_cip: Optional[bool] = None
    r"""Indicates whether the foreign financial institution has a Customer Identification Program (CIP)"""
    has_kyc: Optional[bool] = None
    r"""Indicates whether the foreign financial institution has a Know Your Customer (KYC) program"""
    pep_edd_procedure_description: Optional[str] = None
    r"""A description of the procedure for enhanced due diligence for politically exposed person customers of the FFI"""
