"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .brokerresponsescreate import BrokerResponsesCreate, BrokerResponsesCreateTypedDict
from .ffiamlprogramcreate import FfiAmlProgramCreate, FfiAmlProgramCreateTypedDict
from .ffiservicingoffiscreate import (
    FfiServicingOfFisCreate,
    FfiServicingOfFisCreateTypedDict,
)
from ascend_sdk.types import BaseModel
from typing import Optional, TypedDict
from typing_extensions import NotRequired


class FfiEddCreateTypedDict(TypedDict):
    r"""Enhanced Due Diligence fields required for Foreign Financial Institutions."""

    broker_responses: NotRequired[BrokerResponsesCreateTypedDict]
    r"""Broker Response detail."""
    customer_annual_independent_audit_of_aml_program: NotRequired[bool]
    r"""Indicates whether the customer conducts an annual independent audit of their AML program"""
    customer_annual_independent_audit_unsatisfactory_rating: NotRequired[bool]
    r"""Indicates whether the customer's annual independent audit of their AML program received an unsatisfactory rating"""
    customer_or_affiliates_regulatory_or_criminal_enforcement_for_aml_violations: NotRequired[
        bool
    ]
    r"""Indicates whether the customer or their affiliates have faced regulatory or criminal enforcement for AML violations"""
    customer_or_affiliates_regulatory_or_criminal_enforcement_for_aml_violations_description: NotRequired[
        str
    ]
    r"""Description of the regulatory or criminal enforcement faced by the customer or their affiliates for AML violations"""
    customer_or_affiliates_subject_of_terrorist_financing_matter: NotRequired[bool]
    r"""Indicates whether the customer or their affiliates have been subject to a terrorist financing matter"""
    customer_or_affiliates_subject_of_terrorist_financing_matter_description: NotRequired[
        str
    ]
    r"""Description of the terrorist financing matter that the customer or their affiliates have been subject to"""
    ffi_aml_program: NotRequired[FfiAmlProgramCreateTypedDict]
    r"""Foreign Financial Institution Anti-Money Laundering Program detail."""
    ffi_servicing_of_fis: NotRequired[FfiServicingOfFisCreateTypedDict]
    r"""Foreign Financial Institution servicing financial institutions detail."""
    geographical_markets_served: NotRequired[str]
    r"""The geographical markets served by the foreign financial institution"""
    negative_information_regarding_ffi_aml_record: NotRequired[str]
    r"""Negative information regarding the AML record of the foreign financial institution such as public information in standard guides, periodicals, and major publications"""
    regulating_body_overseeing_ffi: NotRequired[str]
    r"""The regulating body overseeing the foreign financial institution"""


class FfiEddCreate(BaseModel):
    r"""Enhanced Due Diligence fields required for Foreign Financial Institutions."""

    broker_responses: Optional[BrokerResponsesCreate] = None
    r"""Broker Response detail."""
    customer_annual_independent_audit_of_aml_program: Optional[bool] = None
    r"""Indicates whether the customer conducts an annual independent audit of their AML program"""
    customer_annual_independent_audit_unsatisfactory_rating: Optional[bool] = None
    r"""Indicates whether the customer's annual independent audit of their AML program received an unsatisfactory rating"""
    customer_or_affiliates_regulatory_or_criminal_enforcement_for_aml_violations: Optional[
        bool
    ] = None
    r"""Indicates whether the customer or their affiliates have faced regulatory or criminal enforcement for AML violations"""
    customer_or_affiliates_regulatory_or_criminal_enforcement_for_aml_violations_description: Optional[
        str
    ] = None
    r"""Description of the regulatory or criminal enforcement faced by the customer or their affiliates for AML violations"""
    customer_or_affiliates_subject_of_terrorist_financing_matter: Optional[bool] = None
    r"""Indicates whether the customer or their affiliates have been subject to a terrorist financing matter"""
    customer_or_affiliates_subject_of_terrorist_financing_matter_description: Optional[
        str
    ] = None
    r"""Description of the terrorist financing matter that the customer or their affiliates have been subject to"""
    ffi_aml_program: Optional[FfiAmlProgramCreate] = None
    r"""Foreign Financial Institution Anti-Money Laundering Program detail."""
    ffi_servicing_of_fis: Optional[FfiServicingOfFisCreate] = None
    r"""Foreign Financial Institution servicing financial institutions detail."""
    geographical_markets_served: Optional[str] = None
    r"""The geographical markets served by the foreign financial institution"""
    negative_information_regarding_ffi_aml_record: Optional[str] = None
    r"""Negative information regarding the AML record of the foreign financial institution such as public information in standard guides, periodicals, and major publications"""
    regulating_body_overseeing_ffi: Optional[str] = None
    r"""The regulating body overseeing the foreign financial institution"""
